{program CsBiblio.pas pro TEX  ...  autor J.Jevicky, 1993}

{$M $1000,0,0}
{$I-}
Uses Crt,Dos;

Const MaxBib=11;
Type s12=string[12];
Var Sou,Zal:NameStr;
    SouAux,ZalAux:s12;
    SAU,SVY:text;
    PocBib:integer;
    Bi:array[1..MaxBib] of s12;

{------------------ Pomocne procedury}

Procedure Pip;
begin Sound(440); Delay(50); NoSound end;

Function TCH:boolean;
begin TCH:=(DosError+DosExitCode)>0 end;

FUNCTION JeChyba(soubor:s12):boolean;
var V:integer;
procedure Chyba;
 begin Writeln('!!! Chyba pri praci se souborem '+soubor); Write('    ');
   JeChyba:=true; Pip
 end;
Begin JeChyba:=false;
 V:=IOResult;
 If V<>0 then
  begin Chyba;
   Case V of
   $01:Writeln('Soubor nebyl nalezen');
   $02..$04:Writeln('Soubor nelze otevrit');
   $05:Writeln('Ze souboru nelze cist');
   $06:Writeln('Do souboru nelze zapisovat');
   $F0:Writeln('Chyba zapisu na disk');
   $F1:Writeln('Adresar je plny');
   else Writeln('V/V chyba :  ',V);
   End;
   EXIT;
  end;
 V:=DosError;
 If V<>0 then
  begin Chyba;
   Case V of
   2:Writeln('Soubor nebyl nalezen');
   8:Writeln('Nedostatek pameti');
   else Writeln('Chyba DOSu :  ',V);
   End;
  end;
End; {JeChyba}

Procedure VymazAUX;
begin Close(SAU); Close(SVY); Erase(SVY) end;

Procedure VymazBib;
var i,j:integer; PB:string[3]; VY:text;
Begin For i:=1 to PocBib do
  begin Str(i,PB); Assign(VY,Bi[i]);Erase(VY);
   j:=IOResult; DosError:=0;
  end;
end;

Procedure VymazBbl;
var VY:text; j:integer;
begin Assign(VY,Zal+'.bbl');Erase(VY);j:=IOResult; DosError:=0;
  Assign(VY,Sou+'.blg');Erase(VY);j:=IOResult; DosError:=0;
  Assign(VY,Zal+'.blg');Rename(VY,Sou+'.blg');j:=IOResult; DosError:=0;
end;

Procedure Test1(Soubor:s12);
begin If JeChyba(Soubor) then begin VymazAUX; HALT(2) end; end;

Procedure Mnoho;
begin Writeln('!!! Pro \bibdata povoleno maximalne ',MaxBib,' souboru *.bib');
  VymazAUX; VymazBib; Pip; HALT(2)
end;

Procedure DvakratBibData;
begin VymazAUX;
  Writeln('!!! Sekvence  \bibdata{  nalezena v souboru '+SouAux+' dvakrat');
  VymazAUX; VymazBib; Pip; HALT(2)
end;

Procedure ChybaTrans(J:s12;Zpet:boolean);
begin Writeln('!!! Chyba pri transformaci souboru  '+J+'  programem TEXCONV');
  If DosError>0 then Writeln('   Chyba DOSu :  ',DosError);
  If Zpet then Erase(SVY) else VymazAUX;
  VymazBib; VymazBbl; Pip; HALT(2)
end;

Procedure ChybaBib;
begin Writeln('!!! Chyba pri zpracovani souboru '+SouAux+' programem BIBTEX');
  If DosError>0 then Writeln('   Chyba DOSu :  ',DosError);
  Erase(SVY); VymazBib; VymazBbl; Pip; HALT(2);
end;

{-------------------  Hlavni procedury}

Procedure OtevriSouboryAUX;
begin Writeln;
 Writeln('**** Program CsBiblio.exe ... Soubor.aux ---> Soubor.bbl');
 Sou:=ParamStr(1); DosError:=0;
 If Sou='' then
  begin Writeln('!!! Nutno zadat    CSBIBLIO <Soubor>');Writeln;Pip;HALT(2) end;
 SouAux:=Sou+'.aux'; Assign(SAU,SouAux); Reset(SAU);
 If JeChyba(SouAux) then HALT(2);
 Zal:='#'+Sou; ZalAux:=Zal+'.aux';Assign(SVY,ZalAux); Rewrite(SVY);
 Test1(ZalAux);
end;

PROCEDURE VytvorZalAuxATransformujBib;
var
 s,s1:string;
 BDpodruhe,Carka:boolean;
 k,p:integer;
 J,J2:s12;
 J0,J1:NameStr;
 PB:string[3];
procedure Zapis;
 begin Writeln(SVY,s);
  If JeChyba(ZalAux) then begin VymazAUX;VymazBib;HALT(2) end;
 end;
Begin BDpodruhe:=false; PocBib:=0;
 While not eof(SAU) do
  begiN Readln(SAU,s); k:=Pos('\bibdata{',s);
   If k=0 Then Zapis Else
   if BDpodruhe then DvakratBibData else
{transformuje BIB}
   begin s1:=s; s:=Copy(s1,1,k+8); Delete(s1,1,k+8); BDpodruhe:=true;
    Repeat k:=Pos(',',s1); p:=Pos('}',s1); Carka:=(k>0)and(k<p);
      if Carka then p:=k;
      J:=Copy(s1,1,p-1); Delete(s1,1,p);
      repeat k:=Pos(' ',J);if k>0 then Delete(J,k,1) until k=0;
      J0:=J; J:=J0+'.bib';
      Inc(PocBib); If PocBib>MaxBib then Mnoho;
      Str(PocBib,PB); J1:='#'+PB+J0; J2:=J1+'.bib'; Bi[PocBib]:=J2;
      s:=s+J1; If Carka then s:=s+',' else s:=s+'}';
      SwapVectors;
      EXEC(GetEnv('EMTEXDRV')+':\EMTEX\EXE\TEXCONV.EXE','-a b.tcp '+J+' '+J2); 
      SwapVectors;
      If TCH then ChybaTrans(J,false);
    Until not Carka;
    s:=s+s1; Zapis;
   end;
  enD;
 If not BDpodruhe then
    Writeln('!!! V souboru '+SouAux+' nebyla nalezena sekvence \bibdata{');
 Close(SAU); Close(SVY);
End; {Vytvor...}

Procedure BibTex;
begin SwapVectors; EXEC(GetEnv('EMTEXDRV')+':\EMTEX\EXE\BIBTEX.EXE',Zal);
 SwapVectors; If TCH then ChybaBib;
end;

Procedure ZpetnaTransformace;
begin SwapVectors;
 EXEC(GetEnv('EMTEXDRV')+':\EMTEX\EXE\TEXCONV.EXE','-e b.tcp '+Zal+'.bbl '+Sou+'.bbl');
 SwapVectors;
 If TCH then ChybaTrans(SouAux,true);
end;

{******}
BEGIN OtevriSouboryAUX;
      VytvorZalAuxATransformujBib;
      BibTex;
      ZpetnaTransformace;
      Erase(SVY); VymazBib; VymazBbl;
      Writeln('**** Vytvoren soubor '+Sou+'.bbl'); Writeln;
END.
