% HEAD.POS
% header for printing two A4 pages on one sheet, reduced by 0.7
% landscape
% Juergen Gloeckner, Ph.-Schmittstr. 8B, D-W-6902 Sandhausen
%
userdict begin
  /start-hook
  { /cm {72 mul 2.54 div} def /bp {1 cm div def} def
    /@COUNT 1 def /@SHOWPAGE {showpage} bind def
    /SHIFT {@XSHIFT @YSHIFT translate} def /showpage {} def
    90 rotate 0.7 dup scale  %%% for A4 pages
%+++++ 90 rotate       %%% for A5 pages
  } def
  /end-hook
  { showpage
  } def
  /bop-hook
  { gsave
    @COUNT 1 eq
       {/@XSHIFT .5 cm def /@YSHIFT -31 cm def /showpage {} def SHIFT} if
%+++++ position of the first page on the sheet of paper (in cm)
%+++++ the pages are reduced by 0.7 for A4
    @COUNT 2 eq
       {/@XSHIFT 20.5 cm def /@YSHIFT -31 cm def
%+++++ position of the second page on the sheet of paper
        /showpage {@SHOWPAGE} def SHIFT} if
    3 @COUNT sub /@COUNT exch def
  } def
  /eop-hook
  { grestore
  } def
 end
%
% ----- end header file